%  Sistema continuo

num=[2];
den=[1 2 4 2];
[A,B,C,D]=tf2ss(num,den)

% discretizacion

per=0.1;

[Ad,Bd,Cd,Dd] = C2DT(A,B,C,per,0);

%  Valores del ruido

G=eye(size(A));
Qm=0.1
Q=diag([Qm Qm/2 Qm])
R=0.005


% calculo de la matriz de Kalman

[L,M,P,E] = DLQE(A,G,C,Q,R);

L

% Generar la seal de entrada
t = [0:per:10]';
u = sin(t);

% Generar ruidos
pnoise = sqrt(Qm)*randn(length(t),1);
snoise = sqrt(R)*randn(length(t),1);

% Generar la respuesta temporal del proceso
[y1,x] = dlsim(Ad,Bd,Cd,Dd,u+pnoise);
y=y1 + snoise;

yy=[y(2:length(y)); y(length(y))];
a=Ad-L*C*Ad;
b=[Bd-L*C*Bd L];
c=Cd;
d=[Dd 0];

uf=[u yy];

[yf,xf] = dlsim(a,b,c,d,uf);

clf

subplot(221), plot(t,x(:,1),t,xf(:,1)), ylabel('estado 1, azul real')
subplot(222), plot(t,x(:,2),t,xf(:,2)), ylabel('estado 2, azul real')
subplot(223), plot(t,x(:,3),t,xf(:,3)), ylabel('estado 3, azul real')
subplot(224), plot(t,y,t,yf), ylabel('salida, azul real')

